#include "stdafx.h"
#include "IkAES.h"
#include <openssl/ssl.h>
#include <openssl/aes.h>
#include <openssl/rsa.h>
#include <openssl/evp.h>
#include <openssl/rand.h>
#include <openssl/err.h>

CIkAES::CIkAES(void)
{
	memset( m_key, 0, IKAES_CRYPT_KEY_SIZE );
	memset( m_iv, 0, IKAES_CRYPT_IV_SIZE );
}

CIkAES::~CIkAES(void)
{
}

int CIkAES::GenerateNewCryptKey()
{
	return RAND_bytes( m_key, IKAES_CRYPT_KEY_SIZE );
}

const BYTE * CIkAES::GetCryptKey()
{
	return m_key;
}

bool CIkAES::SetCryptKey(const BYTE * pKey)
{
	memcpy( m_key, pKey, IKAES_CRYPT_KEY_SIZE );
	return true;
}

const BYTE * CIkAES::GetInitialVector()
{
	return m_iv;
}

bool CIkAES::SetInitialVector(const BYTE * pKey)
{
	memcpy( m_iv, pKey, IKAES_CRYPT_IV_SIZE );
	return true;
}

int CIkAES::Encrypt(const BYTE * pSrc, int nSrcLen, BYTE * pOutBuffer)
{
	int outlen, tmplen;
	EVP_CIPHER_CTX ctx;

	EVP_CIPHER_CTX_init(&ctx);
	EVP_EncryptInit(&ctx, EVP_aes_128_cbc(), m_key, m_iv);

	EVP_EncryptUpdate(&ctx, pOutBuffer, &outlen, pSrc, nSrcLen);

	EVP_EncryptFinal(&ctx, pOutBuffer + outlen, &tmplen);
	EVP_CIPHER_CTX_cleanup(&ctx);

	outlen += tmplen;

	return outlen;
}

int CIkAES::Decrypt(const BYTE * pSrc, int nSrcLen, BYTE * pOutBuffer)
{
	int outlen, tmplen;
	EVP_CIPHER_CTX ctx;

	EVP_CIPHER_CTX_init(&ctx);
	EVP_DecryptInit(&ctx, EVP_aes_128_cbc(), m_key, m_iv);

	EVP_DecryptUpdate(&ctx, pOutBuffer, &outlen, pSrc, nSrcLen);

    EVP_DecryptFinal(&ctx, pOutBuffer + outlen, &tmplen);
	EVP_CIPHER_CTX_cleanup(&ctx);

    outlen += tmplen;
    
    return outlen;
}
